#include "RadioShield.h"
#include "SerialInterface.h"
#include "TwoWire.h"

#include <avr/pgmspace.h>


template<int n>
class CommandBuffer
{
public:
  void setField8(uint8_t idx,  uint8_t value)  { buffer[idx] = value; }
  void setField16(uint8_t idx, uint16_t value) { buffer[idx] = value & 0xFF; buffer[idx + 1] = (value >> 8) & 0xFF; }
  void setField32(uint8_t idx, uint32_t value) { setField16(idx, value & 0xFFFF); setField16(idx + 2, (value >>  16) & 0xFFFF);}

  constexpr uint8_t  getField8 (uint8_t idx) const { return buffer[idx];}
  constexpr uint16_t getField16(uint8_t idx) const { return buffer[idx] | ((uint16_t)buffer[idx + 1] << 8);}
  constexpr uint32_t getField32(uint8_t idx) const { return getField16(idx) | (((uint32_t)getField16(idx + 2)) << 16);}
  
  uint8_t buffer[n];
};

extern const uint8_t si4688_minipatch[4 + 940]              PROGMEM;
extern const uint8_t si4688_powerup_cmd[16]                 PROGMEM;
extern const uint16_t si4688_shield_properties[5]           PROGMEM;
extern const uint16_t si4688_shield_fm_properties[2 + 1]    PROGMEM;
extern const uint16_t si4688_shield_dab_properties[16 + 1]  PROGMEM;

Si4688State 
RadioShieldImplementation::getSi4688State() const
{
  static constexpr uint8_t pinmsk = pcal6804_pinmsk_si4688_i2cen | pcal6804_pinmsk_si4688_reset;
  
  if( (pcal6408_configreg & pinmsk) != 0)
    return Si4688State::Standby;

  if((si4688_status[3] & 0xC0) == 0)
    return Si4688State::PowerOn;
    
  if((si4688_status[3] & 0xC0) == 0x80)
    return Si4688State::Bootloader;

  return Si4688State::Unkown;
}

bool
RadioShieldImplementation::shutdownSi4688()
{
  pcal6408_configreg |= (pcal6804_pinmsk_si4688_i2cen | pcal6804_pinmsk_si4688_reset); 

  if(!update_pcal6408())
    return false;

   delay(10);

  return true;  
}


bool
RadioShieldImplementation::resetSi4688()
{
  shutdownSi4688();

  pcal6408_configreg &= ~pcal6804_pinmsk_si4688_reset; 
  
  if(!update_pcal6408())
    return false;
    
  delay(5);

  pcal6408_configreg &= ~pcal6804_pinmsk_si4688_i2cen; 
  
  if(!update_pcal6408())
    return false;

  if(!waitSi4688Ready())
    return false;


  if((si4688_status[3] & 0xC0) != 0x00)
    return false;
    
  /* send powerup */
  if (i2c_write_P(i2caddr_si4688, si4688_powerup_cmd, 16) != 0)
    return false;

  return waitSi4688Ready();
}

bool 
RadioShieldImplementation::waitSi4688Ready()
{
  unsigned long ts;


  ts = millis() + 500;
  do
  {
    si4688_status[0] = CMD_RD_REPLY;
    if (i2c_write_read(i2caddr_si4688, si4688_status, 1, 4) != 4)
      return false;
      
    if(si4688_status[0] & 0x80)
      return true;
  } while ( ((unsigned int)(ts - millis())) >= 0);
  
  Serial.print(F("# Si4688: Rdy timeout: ")); SerialIf.print_hex(si4688_status,4); Serial.println(F(""));
  
  return false;
}

bool
RadioShieldImplementation::doSi4688LoadInit()
{
  uint8_t retry;
  uint8_t buf[2];
    
  /* send load_init */
  buf[0] = CMD_LOAD_INIT; buf[1] = 0;
  if (i2c_write_read(i2caddr_si4688, buf, 2, 0) != 0)
    return false;

  for(retry = 200; retry >0; --retry)
  {
    if (!waitSi4688Ready())
      return false;
      

    if((si4688_status[3] & 0xC0) == 0x80)
      break;
      
    delay(10);
  }
   
  if(retry == 0)
    return false;

  return true;
}

bool
RadioShieldImplementation::doSi4688BootFirmware(uint32_t flash_address)
{
  CommandBuffer<16> cmd;
  uint8_t retry;
  uint8_t buf[2];

  if(!resetSi4688())
    return false;
    
  if(!doSi4688LoadInit())
    return false;

  if(i2c_write_P(i2caddr_si4688, si4688_minipatch, sizeof(si4688_minipatch)) != 0)
    return false;

  if(!waitSi4688Ready())
     return false;

  if(!doSi4688LoadInit())
    return false;

  /* load the rom patch from flash */
  cmd.setField32(0, CMD_FLASH_PASS_THROUGH);
  cmd.setField32(4, 0x4000);
  cmd.setField32(8, 0);

  if (i2c_write_read(i2caddr_si4688, cmd.buffer, 12, 0) != 0)
    return false;

  if(!waitSi4688Ready())
     return false;

  if(!doSi4688LoadInit())
    return false;

  /* load selected firmware from flash */
  cmd.setField32(0, CMD_FLASH_PASS_THROUGH);
  cmd.setField32(4, flash_address);
  cmd.setField32(8, 0);

  if (i2c_write_read(i2caddr_si4688, cmd.buffer, 12, 0) != 0)
    return false;

  if(!waitSi4688Ready())
     return false;

  /* boot the firmware */
  cmd.setField16(0, CMD_BOOT);

  if (i2c_write_read(i2caddr_si4688, cmd.buffer, 2, 0) != 0)
    return false;

  if(!waitSi4688Ready())
     return false;

  if((si4688_status[3] & 0xC0) != 0xC0)
    return false;

  return setSi4688Properties_P(si4688_shield_properties);
}

bool
RadioShieldImplementation::setSi4688Property(uint16_t property, uint16_t value)
{
  CommandBuffer<6> cmd;

  cmd.setField16(0, CMD_SET_PROPERTY);
  cmd.setField16(2, property);
  cmd.setField16(4, value);

  if (i2c_write_read(i2caddr_si4688, cmd.buffer, 6, 0) != 0)
    return false;

  return waitSi4688Ready();
}

bool
RadioShieldImplementation::setSi4688Properties_P(uint16_t *props)
{
  do {
    uint16_t property, value;  

    property = pgm_read_word_near(props++);

    if(property == 0xFFFF)
      return true;

    value = pgm_read_word_near(props++);

    if(!setSi4688Property(property, value))
      return false;
      
  } while(1);

  return false;
}

bool
RadioShieldImplementation::beginDABMode()
{
  if(!RadioShield.doSi4688BootFirmware(0xa0000))
    return false;

  return setSi4688Properties_P(si4688_shield_dab_properties);
}

bool
RadioShieldImplementation::beginFMMode()
{
  if(!RadioShield.doSi4688BootFirmware(0x08000))
    return false;

  return setSi4688Properties_P(si4688_shield_fm_properties);
}


bool
RadioShieldImplementation::seekFM(bool backward)
{
  CommandBuffer<10> cmd;

  cmd.setField16(0, CMD_FM_SEEK_START);
  if(backward)
    cmd.setField16(2, MSK_WRAP);
  else
    cmd.setField16(2, MSK_WRAP | MSK_SEEKUP);
        
  cmd.setField16(4, 0);

  if (i2c_write_read(i2caddr_si4688, cmd.buffer, 6, 0) != 0)
    return false;

  if (!waitSi4688Ready())
    return false;

  do { /* loop until seek stopped */
    cmd.setField16(0, CMD_FM_RSQ_STATUS);
    
    if (i2c_write_read(i2caddr_si4688, cmd.buffer, 2, 0) != 0)
      return false;

    if (!waitSi4688Ready())
      return false;

    cmd.setField8(0, CMD_RD_REPLY);
    if (i2c_write_read(i2caddr_si4688, cmd.buffer, 1, 10) != 10)
      return false;

  } while ((cmd.getField8(0) & MSK_STATUS0_STCINT) == 0);

  freq        = cmd.getField16(6) * (uint32_t)10;
  rssi        = cmd.getField16(9);
  signal_good = (cmd.getField8(5) & 0x01) != 0;

  return true;
}


constexpr static uint8_t  clk_mode  = 1;
constexpr static uint8_t  tr_size   = 0x7;        /* for 19.2 Mhz crystal */
constexpr static uint8_t  ibias     = 600 / 10 ;  /* 600 µA startup bias */
constexpr static uint8_t  ibias_run = 200 / 10;   /* 100 µA runtime bias */
constexpr static uint32_t freq      = 19200000;   /* crystal freq */
constexpr static uint8_t  ctun      = static_cast<uint8_t>(2*(8. - 3.) / 0.381); /* tuning capacitance occording to manual */

const uint8_t si4688_powerup_cmd[16] PROGMEM =
{
  CMD_POWER_UP,
  0,
  (clk_mode << 4) | tr_size,
  0x7f & ibias,
  freq & 0xFF,
  (freq >> 8) & 0xFF,
  (freq >> 16) & 0xFF,
  (freq >> 24) & 0xFF,
  0x3f & ctun,
  0x10,
  0,
  0,
  0,
  0x7F & ibias_run,
  0,
  0
};

const uint16_t si4688_shield_properties[4 + 1] PROGMEM =
{
  PROP_DIGITAL_IO_OUTPUT_SELECT,      0x0000, /* I2S Slave */
  PROP_PIN_CONFIG_ENABLE,             0x0002, /* Enable I2S, disable internal DAC */
  0xFFFF
};

const uint16_t si4688_shield_fm_properties[2 + 1] PROGMEM =
{
  /* For FM VHFSW should be open since we're using the "Appendix C
   * Application circuit for EMI mitigation. See AN649, AN650. Since
   * this is the default, we can leave it as is
   * PROP_FM_TUNE_FE_CFG,                          0x0000, */

  /* Enable RDS decoding, try to correct all bit errors */
  PROP_FM_RDS_CONFIG,                 0x00A1, 
  0xFFFF
};

const uint16_t si4688_shield_dab_properties[16 + 1] PROGMEM =
{
  /* For DAB VHFSW should be closed since we're using the "Appendix C
   * Applicatin circuit for EMI mitigation. See AN649, AN650. Since
   * this is the default, we can leave it as is
   * PROP_DAB_TUNE_FE_CFG,                          0x0001, */
  PROP_TUNE_FE_VARM,        static_cast<uint16_t>(-1541),
  PROP_TUNE_FE_VARB,        static_cast<uint16_t>(  394),
  PROP_DAB_VALID_RSSI_TIME,                          63,
  PROP_DAB_VALID_SYNC_TIME,                           0,
  PROP_DAB_VALID_DETECT_TIME,                         0,
  PROP_DAB_ACF_ENABLE,                           0x0000,
  PROP_DAB_CTRL_DAB_MUTE_SIGNAL_LEVEL_THRESHOLD,      0,
  PROB_DAB_ANOUNCEMENTS,                         0x0000,
  0xFFFF
};



const uint8_t si4688_minipatch[4 + 940] PROGMEM = 
{
  0x04, 0x0, 0x0, 0x0, /* host load command */
  
  0x03,0x00,0x00,0xfe,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x78,0x56,0x34,0x12,
  0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x2c,0x5f,0xbe,0x2f,0x01,0x00,0x00,0x00,
  0xef,0xbe,0xad,0xde,0x50,0x03,0x00,0x00,0x03,0x00,0x00,0x00,0x04,0x00,0x00,0x00,
  0x00,0x00,0x00,0x00,0x00,0x3c,0x20,0x50,0x01,0x00,0x00,0x00,0x6a,0x21,0xd6,0x4f,
  0x89,0xa5,0x4c,0xd3,0xd4,0x6e,0x92,0x9f,0xa9,0x31,0x42,0x2e,0x20,0x0f,0xe2,0x2b,
  0x7f,0x72,0xc2,0xd7,0xf0,0x52,0x7e,0xd1,0x99,0x89,0x86,0x4f,0x55,0xe7,0x6d,0xde,
  0x98,0xff,0xd8,0xcc,0x71,0xcf,0xd2,0x78,0x62,0x58,0xa4,0x01,0xa7,0x34,0x6d,0x73,
  0x91,0x31,0xfa,0x15,0x50,0x22,0x9b,0x78,0xb5,0x49,0x2a,0xd1,0x5a,0xde,0x36,0x53,
  0x85,0xdd,0x6d,0x46,0xb8,0x06,0xde,0xec,0x8f,0x25,0xdc,0x6a,0x16,0x4b,0xd8,0x66,
  0x3d,0x9a,0xa2,0x8d,0x68,0xed,0x67,0xcb,0xd1,0x12,0xae,0x75,0x85,0x44,0x5c,0x9b,
  0x83,0xc8,0xd6,0x37,0x96,0x92,0x85,0x9f,0x12,0xb3,0x7d,0x4f,0x7e,0x59,0xcb,0x7d,
  0x0b,0x99,0x97,0x7b,0xc7,0x60,0x50,0x26,0x10,0xfe,0xc1,0xf3,0xe0,0xd1,0xe0,0x16,
  0xd3,0x0d,0xa8,0x1c,0xa6,0xf7,0x58,0x39,0x4f,0x42,0xd3,0x23,0xbf,0x6a,0xc1,0x14,
  0xad,0x7b,0x80,0x01,0x1b,0xcb,0x01,0xe3,0x45,0xea,0x62,0x36,0x8a,0x06,0x04,0xf5,
  0x97,0xcd,0x95,0x84,0xe1,0x56,0xb9,0x29,0xd4,0xc1,0x8e,0x2e,0xec,0x93,0x1d,0xf9,
  0x63,0xf4,0x58,0xe1,0xc6,0x13,0xb0,0x22,0x3e,0x79,0x02,0x54,0xa2,0x2e,0x09,0xc8,
  0xa4,0x7e,0xd2,0xd0,0xaa,0xee,0x27,0xa0,0x97,0x32,0x4c,0xe0,0xa6,0xe9,0xfe,0x3f,
  0xb2,0xad,0x93,0x2c,0x89,0x52,0x58,0x78,0x82,0x89,0xb1,0xf0,0xd4,0x7e,0x60,0x01,
  0x7a,0xbc,0xc1,0x62,0xe5,0x54,0xe4,0x32,0x88,0xc5,0xcb,0x05,0xa1,0xe7,0x98,0x6a,
  0xe2,0x56,0x57,0xf4,0x5e,0x47,0xaf,0xc8,0x8a,0xb3,0x1e,0xd0,0x30,0x5e,0x1d,0xae,
  0x0f,0x2b,0x19,0x3d,0x30,0x06,0x13,0xd8,0x0e,0xd4,0xbe,0x8b,0xe2,0x25,0x1e,0x12,
  0xf5,0xa7,0xbe,0xca,0x1a,0x29,0x8e,0x07,0xa1,0xd0,0x09,0x10,0x45,0xa2,0xb7,0x06,
  0x78,0x23,0xb1,0x99,0x74,0xdf,0x11,0x25,0xbc,0xe5,0xe0,0x17,0x6c,0x4f,0x3a,0x2d,
  0x7a,0xf7,0x56,0x9b,0xd6,0x9d,0xaa,0x24,0xdb,0x5b,0xbd,0xcd,0xd2,0xdf,0x58,0x6c,
  0x78,0xa2,0x06,0x1f,0xc1,0x18,0xa8,0x2c,0x26,0xc6,0x77,0x16,0x01,0x8b,0x3e,0x7a,
  0x44,0x4a,0xdd,0x06,0xb0,0x0e,0xfb,0x3d,0xbb,0x74,0x39,0xcd,0x57,0xbb,0xfe,0xe3,
  0x36,0x6d,0x24,0x95,0x59,0x6b,0x6f,0x93,0xfa,0x38,0xf0,0xc9,0xd9,0xe4,0xc4,0xe1,
  0x02,0x81,0xa3,0xbd,0x18,0x72,0x49,0xf2,0x88,0x09,0xf1,0x5a,0x59,0x3d,0x75,0xca,
  0xa6,0x15,0xb0,0x5e,0x7a,0x7c,0xe6,0x87,0x9c,0x27,0xa7,0x1f,0x10,0x4d,0x68,0x8c,
  0x4d,0xd7,0x7c,0x38,0x68,0xa9,0x63,0xc4,0xda,0xa9,0x89,0x7d,0xa2,0xe4,0xed,0x21,
  0x0f,0x82,0x9c,0x4e,0xd9,0x4b,0x9f,0xd0,0x61,0x36,0x94,0x2e,0x61,0xd2,0x1a,0x6a,
  0x31,0x3b,0x2b,0x7b,0x14,0xb5,0x4c,0x3d,0x89,0x8e,0x7b,0xa7,0x3d,0xd8,0x18,0x65,
  0x7d,0xbd,0xec,0xd2,0x3f,0x00,0xc1,0xf1,0x8c,0xbd,0xee,0x01,0xeb,0x27,0xf5,0xda,
  0x34,0xae,0x15,0x0e,0x49,0xf1,0x54,0x9f,0xd3,0xcd,0xbc,0x9f,0x11,0x55,0x5c,0xff,
  0xea,0xf9,0x9a,0x3a,0xb3,0xa3,0x2b,0xc2,0x1c,0xe2,0x0b,0x37,0xfb,0x78,0x27,0x8e,
  0xb0,0xe0,0xe6,0x6c,0xa1,0x29,0x32,0x6f,0xe4,0x07,0xd3,0x09,0xf6,0x71,0xa8,0x8b,
  0xd6,0x96,0x8e,0xb7,0x3d,0xa2,0x3e,0x40,0xd8,0x13,0x69,0x7e,0xa1,0xe9,0xd2,0x55,
  0xfb,0x22,0xbb,0x1a,0xbe,0x53,0xc5,0xce,0x9b,0x9c,0x04,0x2e,0xe5,0x45,0x72,0x8a,
  0x80,0x87,0x8a,0xfe,0xf6,0x52,0xc2,0x6e,0x4e,0x0e,0x62,0x8b,0x86,0xfc,0x9f,0x23,
  0x11,0x44,0x19,0xdf,0x8a,0xdf,0x4a,0x01,0x17,0xa8,0x37,0xab,0xa3,0x7b,0xa4,0x0d,
  0x1e,0xd8,0x92,0xe9,0x86,0x3d,0x22,0x79,0xb6,0x3e,0xab,0x97,0xf7,0x8e,0x32,0x12,
  0xda,0x4e,0x8b,0x3f,0x21,0x80,0x62,0x1f,0x30,0x16,0x2b,0x9e,0x08,0xbb,0xe1,0x7b,
  0x32,0xc6,0x01,0x8e,0x8c,0x04,0x22,0xcf,0xda,0x2a,0xf5,0xd9,0x9c,0xe5,0x48,0x5b,
  0xfd,0x6f,0xde,0x72,0xb0,0xff,0x6d,0x53,0x46,0x4f,0x19,0xdf,0x1b,0x3d,0x11,0xeb,
  0xfb,0x78,0xfd,0x9e,0xc0,0x41,0x58,0xf6,0xd7,0xe0,0xf4,0xae,0xd7,0xee,0x38,0xcf,
  0xc9,0x02,0x53,0x53,0x72,0xde,0xe1,0xf5,0x0d,0x91,0x72,0xa3,0x57,0xb5,0x8c,0xd3,
  0x5c,0x84,0x57,0x52,0xa3,0x61,0x3a,0xfb,0x55,0x22,0x13,0x0f,0x5f,0x20,0x72,0xdc,
  0xd6,0x6c,0x33,0x32,0xb8,0x66,0x6b,0x7d,0x5f,0x84,0x91,0x04,0x23,0x75,0x5d,0xa1,
  0xb9,0xdc,0xd6,0x44,0x33,0xc7,0xd0,0x18,0x7e,0x3c,0x6f,0x3f,0x5d,0x7f,0xe0,0xcf,
  0xd0,0x88,0xbe,0xf1,0x87,0x65,0x65,0xda,0xcc,0xd2,0x75,0x5f,0x8f,0xf7,0xb3,0x08,
  0x68,0xf7,0xde,0xfe,0xe2,0x5f,0x95,0xa2,0x92,0xf6,0x41,0xa7,0x45,0xf6,0x34,0x20,
  0xe5,0x5f,0x46,0x31,0xdd,0xd5,0xda,0xb1,0x5e,0xb6,0x06,0x34,0xd9,0x22,0xf3,0x95,
  0xc3,0xd1,0xbc,0xcf,0xab,0x83,0x6e,0x5d,0x38,0x3a,0xc8,0xbd,0xe8,0x11,0xaf,0xc9,
  0x01,0x0c,0x20,0x7b,0x18,0xfb,0x38,0xbc,0xfd,0xe7,0xce,0x96,0xa2,0x50,0xf4,0x4d,
  0x93,0x22,0x93,0x5b,0x4e,0x93,0xf2,0x93,0xc6,0xba,0x45,0xe2,0x08,0xf1,0xaa,0x0b,
  0x06,0x35,0x84,0x64,0x0c,0x38,0x1e,0x9c,0xe8,0x68,0x79,0x93,0x11,0x7d,0xab,0x17,
  0x1a,0x44,0x24,0xd8,0xb5,0xdb,0xe0,0x0f,0x9c,0x51,0x99,0x0a,0x08,0xda,0x90,0x71,
  0xa5,0x12,0xaf,0x12,0xf3,0x3c,0xbc,0x8e,0x17,0x27,0x11,0x16,0xf8,0x22,0x40,0xfd,
  0xbc,0x2b,0xbb,0x78,0x25,0xa7,0x04,0xf5,0x00,0x00,0x00,0x00
};
